modded class MissionGameplay
{
    Entity m_CurrLooking;

    override void OnKeyPress(int key)
	{
		super.OnKeyPress(key);

        if (key == KeyCode.KC_K && m_CurrLooking)
        {
            if (m_CurrLooking.GetAnimationPhase("test_hide") == 1)
            {
                m_CurrLooking.SetAnimationPhase("test_hide", 0);
            }
            else
            {
                m_CurrLooking.SetAnimationPhase("test_hide", 1);
            }
        }

        if (key == KeyCode.KC_J && m_CurrLooking)
        {
            if (m_CurrLooking.GetAnimationPhase("test_translation") == 1)
            {
                m_CurrLooking.SetAnimationPhase("test_translation", 0);
            }
            else
            {
                m_CurrLooking.SetAnimationPhase("test_translation", 1);
            }
        }
    }

    override void OnUpdate(float timeslice)
	{
        super.OnUpdate(timeslice);

        vector rayStart = GetGame().GetCurrentCameraPosition();
        vector rayEnd = rayStart + GetGame().GetCurrentCameraDirection() * 5.0;

        RaycastRVParams rayInput = new RaycastRVParams(rayStart, rayEnd, GetGame().GetPlayer());
		rayInput.flags = CollisionFlags.ALLOBJECTS;
		array<ref RaycastRVResult> results = new array<ref RaycastRVResult>;

        if ( DayZPhysics.RaycastRVProxy(rayInput, results) )
		{
			if ( results.Count() > 0 )
			{
                Entity found = null;
				for( int i = 0; i < results.Count(); i++)
				{
                    RaycastRVResult res = results[i];
                    if (res.obj && res.obj.IsKindOf("Land_test_box"))
                    {
                        found = Entity.Cast(res.obj);

                        string name = found.GetActionComponentName(res.component, "view");

                        GetGame().GetMission().OnEvent( ChatMessageEventTypeID, new ChatMessageEventParams( CCDirect, "", "name component : " + name, "" ) );
                        break;
                    }
                }
                m_CurrLooking = found;
            }
            else
            {
                m_CurrLooking = null;
            }
        }
        else
        {
            m_CurrLooking = null;
        }

        if (!m_CurrLooking)
        {
            GetGame().GetMission().OnEvent( ChatMessageEventTypeID, new ChatMessageEventParams( CCDirect, "", "not found", "" ) );
        }
    }
}